C ----------------------------------------------------------------------
C
C Fr  Calcul d'une matrice de correlation de Pearson et test des  
C     coefficients de correlation par permutation des donnees.
C
C Eng Computation of a Pearson correlation matrix and test of the
C     correlation coefficients by permutation of the data.
C
C ----------------------------------------------------------------------
C
C     nmax = nombre maximum d'objets (n = nombre reel d'objets)
C     pmax = nombre maximum de variables (p = nombre reel de variables)
C
C     Entree des donnees:
C     Les variables sont les colonnes du fichier d'entree.
C     
C                                         Pierre Legendre, decembre 2000
C
C ----------------------------------------------------------------------
C2345678901234567890123456789012345678901234567890123456789012345678901234567890
      Integer n,nmax,p,pmax
      Parameter (nmax=1000,pmax=101)
      Integer iordre(nmax),iGE(pmax)
      Real*8 X(nmax,pmax),R(pmax,pmax),Prob(pmax,pmax),dfln,dflnm1,
     +       temp,rtemp,corref(pmax)
      Character tt*10
C Langue du dialogue / Dialog language: 1 = francais; 2 = English
    1 write(*,*) 'Francais: tapez (1)'
      write(*,*) 'English:  type  (2)'
      read(*,*) langue
      if((langue.lt.1).or.(langue.gt.2)) goto 1
      if(langue.eq.1) then
         write(*,106)
         else
         write(*,206)
         endif
C BBEdit is the 'creator' for output files
C      call F_Creator('R*ch')
C Fichier des resultats
      open(1,file='CorrProb.txt',   status='NEW')
      open(2,file='Correlat.txt',status='NEW')
      open(3,file='Prob.txt',       status='NEW')
      if(langue.eq.1) then
         write(1,106)
         write(2,106)
         write(3,106)
         else
         write(1,206)
         write(2,206)
         write(3,206)
         endif
C Lecture des donnees, etc.
      call Lecture(n,p,X,nmax,pmax,langue)
      if(langue.eq.1) write(*,*) 'Coefficients de correlation: ',
     +   'Test (1) unilateral ou (2) bilateral?'
      if(langue.eq.2) write(*,*) 
     +'Correlation coefficients: (1) one-tailed or (2) two-tailed ',
     +'test?'
      read(*,*) itail
      write(*,*)
      if(langue.eq.1) write(*,*) 'Combien de permutations? ',
     +   '(e.g. 999, 9999, ...)'
      if(langue.eq.2) write(*,*) 'How many permutations? ',
     +   '(e.g. 999, 9999, ...)'
      read(*,*) nperm
      if(itail.eq.1) then
         if(langue.eq.1) then
            write(1,*) 'Coefficients de correlation: ',
     +                 'Test unilateral dans la direction du signe'
            write(2,*) 'Coefficients de correlation: ',
     +                 'Test unilateral dans la direction du signe'
            write(3,*) 'Coefficients de correlation: ',
     +                 'Test unilateral dans la direction du signe'
            else
            write(1,*) 'Correlation coefficients: ',
     +                 'One-tailed test in direction of the sign'
            write(2,*) 'Correlation coefficients: ',
     +                 'One-tailed test in direction of the sign'
            write(3,*) 'Correlation coefficients: ',
     +                 'One-tailed test in direction of the sign'
            endif
         else
         if(langue.eq.1) then
            write(1,*) 'Coefficients de regression: Test bilateral'
            write(2,*) 'Coefficients de regression: Test bilateral'
            write(3,*) 'Coefficients de regression: Test bilateral'
            else
            write(1,*) 'Correlation coefficients: Two-tailed test'
            write(2,*) 'Correlation coefficients: Two-tailed test'
            write(3,*) 'Correlation coefficients: Two-tailed test'
            endif
         endif
      write(1,*)
      write(2,*)
      write(3,*)
      if(langue.eq.1) then
         write(1,107) nperm
         write(2,108) 
         write(3,109) nperm
         else
         write(1,207) nperm
         write(2,208) 
         write(3,209) nperm
         endif
      write(*,*)
C Demarrer l'horloge
      debut=secnds(0.0)
C      call time(tt)
      if(langue.eq.1) then
         write(*,102) tt
         else
         write(*,202) tt
         endif
C Calcul des degres de liberte.
      dfln=dfloat(n)
      dflnm1=dfloat(n-1)
C Centrage et reduction de chaque variable de la matrice X
      call Standard(n,p,nmax,pmax,X,dfln,dflnm1)
C Preparation en vue des permutations
      do 12 i=1,n
   12 iordre(i)=i
      iseed=0
      do 14 i=1,100
   14 turn=rand(iseed)
      do 16 j=1,p
      R(j,j)=1.0
   16 Prob(j,j)=0.0
C Calcul des correlations et tests par permutation
      do 50 ii=1,(p-1)
C
      do 22 jj=(ii+1),p
      iGE(jj)=1
      temp=0.0
      do 20 i=1,n
   20 temp=temp+X(i,ii)*X(i,jj)
      corref(jj)=temp/dflnm1
      R(ii,jj)=corref(jj)
      R(jj,ii)=corref(jj)
   22 continue
C Debut de la boucle de permutation - - - - - - - - - - - - - - - - - - - - - - - - -
C On permute seulement la variable 'ii' consideree dans la boucle 50
      do 36 k=1,nperm
      call Permute(iseed,n,nmax,iordre)
C
      do 34 jj=(ii+1),p
      rtemp=0.0
      do 32 i=1,n
   32 rtemp=rtemp+X(iordre(i),ii)*X(i,jj)
      rtemp=rtemp/dflnm1
C
      if(itail.eq.1) then
         if(corref(jj).ge.0.0) then
            if(rtemp.ge.corref(jj)) iGE(jj)=iGE(jj)+1
            else
            if(rtemp.le.corref(jj)) iGE(jj)=iGE(jj)+1
            endif
         else
         if(dabs(rtemp).ge.dabs(corref(jj))) iGE(jj)=iGE(jj)+1
         endif
   34 continue
C
   36 continue
C Fin de la boucle de permutation - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C Calcul des probabilites permutationnelles
      do 38 jj=(ii+1),p
      Prob(ii,jj)=dfloat(iGE(jj))/dfloat(nperm+1)
   38 Prob(jj,ii)=Prob(ii,jj)
C
   50 continue
C Impression des resultats
      do 60 ii=1,p
      write(1,100) (R(ii,jj), jj=1,p)
      write(2,100) (R(ii,jj), jj=1,p)
      write(1,101) (Prob(ii,jj), jj=1,p)
      write(3,101) (Prob(ii,jj), jj=1,p)
   60 write(1,*)
C Duree du calcul?
      write(*,*)
      fin=secnds(debut)
      if(langue.eq.1) then
         write(*,110) fin
         write(*,*) "Les resultats se trouvent dans les fichiers"
         write(*,*) "'CorrProb.out', 'Correlation.out' et 'Prob.out'"
         write(*,*)
         write(*,*) 'Fin du programme.'
         else
         write(*,210) fin
         write(*,*) "Results have been written to files"
         write(*,*) "'CorrProb.out', 'Correlation.out' and 'Prob.out'"
         write(*,*)
         write(*,*) 'End of the program.'
         endif
      close(1)
      close(2)
      close(3)
      stop
C
  100 format(101f9.5)
  101 format(101(1x,f8.4))
  102 format(' Debut des calculs:  ',a10)
  202 format(' Computation started at  ',a10)
  106 format(' Programme de correlation lineaire avec tests par',
     +       ' permutation'//
     +       ' Pierre Legendre'/
     +       ' Departement de sciences biologiques'/
     +       ' Universite de Montreal.'/
     +       '             (c) Pierre Legendre, 2000'/)
  206 format(' Program for linear correlation with permutation tests'//
     +       ' Pierre Legendre'/
     +       ' Departement de sciences biologiques'/
     +       ' Universite de Montreal.'/
     +       '             (c) Pierre Legendre, 2000'/)
  107 format(' Matrice carree des correlations. Pour chaque',
     +       ' correlation:'/
     +       ' ligne 1 = correlation,  ligne 2 = probabilite (',i6,
     +       ' permutations)'/)
  207 format(' Square correlation matrix. For each correlation:'/
     +       ' Line 1 = correlation,  line 2 = probability (',i6,
     +       ' permutations)'/)
  108 format(' Matrice carree des correlations'/)
  208 format(' Square correlation matrix'/)
  109 format(' Matrice carree des probabilites (',i6,' permutations)'/)
  209 format(' Square matrix of probabilities (',i6,' permutations)'/)
  110 format(' Duree du calcul:',f10.2,' sec.'/)
  210 format(' Computation time:',f10.2,' sec.'/)
      end
      
      Subroutine Lecture(n,p,X,nmax,pmax,langue)
      Integer p,pmax
      Real*8 X(nmax,pmax)
      Character*79 nom
C2345678901234567890123456789012345678901234567890123456789012345678901234567890
C Lecture des donnees  
      write(*,*)
      if(langue.eq.1) write(*,*) 
     +'Fichier de donnees (variables en colonnes)?'
      if(langue.eq.2) write(*,*) 
     +'Input data file (variables are the columns)?'
      read(*,*) nom
      open(10,file=nom,status='OLD')
      inquire(unit=10,name=nom)
      if(langue.eq.1) then
         write(*,*) 'Fichier de donnees: ', nom
         write(*,*)
         write(*,*) 'Combien d''objets et de variables?', 
     +              ' (Exemple: 50 25)'
         else
         write(*,*) 'Input data file: ', nom
         write(*,*)
         write(*,*) 'How many objects and variables? (Example: 50 25)'
         endif
      read(*,*) n,p
      if((n.gt.nmax).or.(p.gt.pmax)) goto 99
C 
      do 10 i=1,n
   10 read(10,*) (X(i,j), j=1,p)
      close(10)
C
      if(langue.eq.1) then
         write(*,101) nom,n,p
         write(1,101) nom,n,p
         write(2,101) nom,n,p
         write(3,101) nom,n,p
         else
         write(*,201) nom,n,p
         write(1,201) nom,n,p
         write(2,201) nom,n,p
         write(3,201) nom,n,p
         endif
      return
C
   99 continue
      if(langue.eq.1) write(6,103)
      if(langue.eq.2) write(6,203)
      stop 3
  101 format(/' Fichier de donnees: ',a32/
     +        i6,' objets'/
     +        i6,' variables'/)
  103 format(' Probleme trop grand: re-dimensionnez le programme.')
  201 format(/' Input data file: ',a32/
     +        i6,' objects'/
     +        i6,' variables'/)
  203 format(' Problem too big. Redimension the program.')
      end

      Subroutine Permute (iseed,n,nmax,iordre)
C This subroutine permutes the first 'n' values of vector 'iordre' at random
C in an equiprobable way. This property has been checked through intensive 
C simulations.
      Integer iseed,n,i,itemp,km1,m
      Integer iordre(nmax)
      m=n
      km1=n-1
      do 10 i=1,km1
    8    j = 1 + rand(iseed)*m
         if(j.gt.m) goto 8
         itemp = iordre(m)
         iordre(m) = iordre(j)
         iordre(j) = itemp
         m=m-1
   10 continue
      return
      end

      Subroutine Standard(n,p,nmax,pmax,X,dfln,dflnm1)
      Integer p,pmax
      Real*8 X(nmax,pmax),sx,sx2,xbar,ety,dfln,dflnm1
C Centrage et reduction de chaque variable de la matrice X.
      do 20 j=1,p
      sx=0.0
      sx2=0.0
      do 10 i=1,n
      sx=sx+X(i,j)
   10 sx2=sx2+X(i,j)*X(i,j)
      xbar=sx/dfln
      ety=(sx2-((sx**2)/dfln))/dflnm1
      ety=dsqrt(ety)
C
      do 12 i=1,n
   12 X(i,j)=(X(i,j)-xbar)/ety
   20 continue
      return
      end

